import java.awt.Component;
import java.awt.Container;
import java.awt.event.ActionEvent;
import java.awt.Image;
import java.awt.Insets;
import java.awt.Frame;
import java.awt.MediaTracker;
import java.awt.Rectangle;
import java.awt.Toolkit;
import java.net.URL;
import java.awt.TextArea;
import java.awt.Color;
import java.awt.Font;
import java.awt.Cursor;
import java.awt.event.KeyEvent;
import java.awt.Toolkit;
import java.awt.Point;
import java.awt.FileDialog;
import java.io.File;
import java.io.FilenameFilter;
import java.awt.Dimension;

import javax.swing.text.DefaultEditorKit;
import javax.swing.text.EditorKit;
import javax.swing.text.Keymap;
import javax.swing.JComponent;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.JScrollBar;
import javax.swing.JScrollPane;
import javax.swing.KeyStroke;
import javax.swing.Action;
import javax.swing.AbstractAction;
import javax.swing.JFileChooser;

class WidgetPrims  extends Primitives {

  BlockHelp blockhelp;

  static String[] primlist={
    "createtext", "5", "createcc", "5", "createline", "5", "createhelp", "3",
    "createalert", "1", "createdialog", "2",  "createinputdialog", "2",
    "setvisible", "2", "setsize", "3", "setlocation", "3",
    "inserttext", "2", "cleartext", "1", "gettext", "1", "setforeground", "2", "setbackground", "2",
    "getcursorpos", "1", "setcursorpos", "2",
    "createcursor", "4", "setcursor", "1","getcursorsize", "0",
    "createscrollbar", "5", "setscrollbarvalue", "2", "scrollbarmaxsize", "1",
    "filedialog", "4",
    "gettextobject", "1", "setexit", "1", "setdragtext", "1", "wscale", "0",
    "setdefaultsavepath", "1"
  };

  public String[] primlist(){return primlist;}

  public Object dispatch(int offset, Object[] args, LContext lc){
    switch(offset){
    case 0: return prim_createtext(args[0], args[1], args[2], args[3], args[4], lc);
    case 1: return prim_createcc(args[0], args[1], args[2], args[3], args[4], lc);
    case 2: return prim_createline(args[0], args[1], args[2], args[3], args[4], lc);
    case 3: return prim_createhelp(args[0], args[1], args[2], lc);
    case 4: return prim_createalert(args[0], lc);
    case 5: return prim_createdialog(args[0], args[1], lc);
    case 6: return prim_createinputdialog(args[0], args[1], lc);

    case 7: return prim_setvisible(args[0],args[1],lc);
    case 8: return prim_setsize(args[0], args[1], args[2], lc);
    case 9: return prim_setlocation(args[0], args[1], args[2], lc);

    case 10: return prim_inserttext(args[0], args[1], lc);
    case 11: return prim_cleartext(args[0], lc);
    case 12: return prim_gettext(args[0],lc);
    case 13: return prim_setforeground(args[0], args[1], lc);
    case 14: return prim_setbackground(args[0], args[1], lc);
    case 15: return prim_getcursorpos(args[0],lc);
    case 16: return prim_setcursorpos(args[0], args[1], lc);

    case 17: return prim_createcursor(args[0], args[1], args[2], args[3], lc);
    case 18: return prim_setcursor(args[0], lc);
    case 19: return new Double (Toolkit.getDefaultToolkit().getBestCursorSize(32, 32).getWidth());

    case 20: return prim_createscrollbar(args[0], args[1], args[2], args[3], args [4], lc);
    case 21: return prim_setscrollbarvalue(args[0], args[1], lc);
    case 22: return prim_scrollbarmaxsize(args[0], lc);

    case 23: return prim_filedialog(args[0], args[1], args[2], args[3], lc);
    case 24: return prim_getTextObject(args[0],lc);
    case 25: return prim_setexit(args[0],lc);
    case 26: lc.canvas.dragtext = Logo.prs(args[0]); return null;
    case 27: return new Double(lc.frame.wscale);
    case 28: defaultpath = new File(Logo.prs(args[0])); return null;
   }
    return null;
  }

   //new Double(Toolkit.getDefaultToolkit().getBestCursorSize(32, 32).getWidth());

//---------------------- TEXT definitions ----------------------------

  Object prim_createtext(Object arg1, Object arg2, Object arg3, Object arg4, Object arg5, LContext lc){
    Rectangle r = lc.canvas.getBounds();
    int left = Logo.anInt(arg1, lc), top = Logo.anInt(arg2, lc);
    int width = Logo.anInt(arg3, lc), height = Logo.anInt(arg4, lc);
    JTextArea text = new JTextArea();
    int rgbbkg = Logo.anInt(arg5, lc);
    JScrollPane scrollPane = new JScrollPane(text,
              JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,
              JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
    double s = lc.frame.wscale;
    scrollPane.setBounds ((int)((left + r.x)*s), (int)((top + r.y)*s), (int)(width*s), (int)(height*s));
    lc.panel.add(scrollPane, 0);
  //  scrollPane.validate();
    Color c = new Color (rgbbkg);
    text.setBackground (c);
    c = new Color (0, 51, 153);
    text.setForeground(c);
    text.setCaretColor(c);
    text.setMargin (new Insets(0, 5, 0, 0));
    text.setSelectionColor(new Color (255, 204, 0));
    text.setFont(new Font("Trebuchet MS", Font.BOLD, 14));
    text.addFocusListener(lc.frame);
    text.addKeyListener(new LCKeyListener(lc));
    initAppleKeys(text);
    lc.panel.validate();
    return scrollPane;
  }

  Object prim_createcc(Object arg1, Object arg2, Object arg3, Object arg4, Object arg5, LContext lc){
    Rectangle r = lc.canvas.getBounds();
    int left = Logo.anInt(arg1, lc), top = Logo.anInt(arg2, lc);
    int width = Logo.anInt(arg3, lc), height = Logo.anInt(arg4, lc);
    int rgbbkg = Logo.anInt(arg5, lc);
    Listener cc=new Listener(5, 5);
      JScrollPane scrollPane = new JScrollPane(cc,
                JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,
                JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
      scrollPane.setBounds (left + r.x, top + r.y, width, height);
    lc.panel.add(scrollPane, 0);
   // scrollPane.validate();
    cc.prefix = "handle-cr ["; cc.suffix="]";
    Color c = new Color (rgbbkg);
    cc.setBackground (c);
    c = new Color (0, 51, 153);
    cc.setForeground(c);
    cc.setCaretColor(c);
    cc.setSelectionColor(new Color (255, 204, 0));
    cc.setMargin (new Insets(0, 5, 0, 0));
    cc.setFont(new Font("Courier", Font.BOLD, 14));
    cc.addKeyListener(new TEKeyListener() );
    cc.addKeyListener(new LCKeyListener(lc));
    cc.lc = lc;
    cc.addFocusListener(lc.frame);
    lc.panel.validate();
    return scrollPane;
  }

//---------------- Statusbar text -------------------
// needs to be change to JTextField

  Object prim_createline(Object arg1, Object arg2, Object arg3, Object arg4, Object arg5, LContext lc){
    Rectangle r = lc.canvas.getBounds();
    int left = Logo.anInt(arg1, lc), top = Logo.anInt(arg2, lc);
    int width = Logo.anInt(arg3, lc), height = 18;
    int rgbtext = Logo.anInt(arg4, lc), rgbbkg = Logo.anInt(arg5, lc);
    JTextArea text = new JTextArea(1,20);
    lc.panel.add (text,0);
    text.setVisible (false);
    double s = lc.frame.wscale;
    text.setBounds ((int)((left + r.x)*s), (int)((top + r.y)*s), (int)(width*s), (int)(height*s));
    text.setMargin (new Insets(2, 5, 0, 0));
    Color c = new Color (rgbtext);
    text.setForeground(c);
    c = new Color (rgbbkg);
    text.setBackground (c);
    text.setFont(new Font("Arial", Font.BOLD, (int)(12*s)));
    text.setEditable(false);
    lc.panel.validate();
    return text;
  }

//--------------------Help System Definitions -----------


  Object prim_createhelp(Object arg1, Object arg2, Object arg3, LContext lc){
    String str = Logo.aString(arg1, lc);
    int left = Logo.anInt(arg2, lc), top = Logo.anInt(arg3, lc);
    if (blockhelp != null) blockhelp.dispose();
    URL u = HelpCanvas.class.getResource("images/" + str);
    if (u == null) return "";
    Image img = Toolkit.getDefaultToolkit().getImage(u);
    MediaTracker mt = new MediaTracker(lc.frame);
    try {
          mt.addImage(img, 0);
          mt.waitForID(0);
        }
    catch(Exception e) {return "";}
    blockhelp = new BlockHelp(img, lc);
    blockhelp.setLocation(left, top);
    blockhelp.setVisible(true);
    return blockhelp;
  }


  Object prim_createalert(Object arg1, LContext lc){
    JOptionPane.showMessageDialog(lc.frame, Logo.prs(arg1), "Alert", JOptionPane.PLAIN_MESSAGE);
    return null;
  }

  Object prim_createdialog(Object arg1, Object arg2, LContext lc){
    String title = Logo.aString(arg1, lc);
  	Object [] options = {"Yes", "No", "Cancel"};
  	lc.frame.toFront();
    int answer = JOptionPane.showOptionDialog(lc.frame, arg2, title,
                      JOptionPane.YES_NO_CANCEL_OPTION,
                      JOptionPane.QUESTION_MESSAGE,
                      null,
                      options,
                      options[0]);
     return options [answer];
  }

  Object prim_createinputdialog(Object arg1, Object arg2, LContext lc){
  	lc.frame.toFront();
    String res = JOptionPane.showInputDialog(lc.frame, Logo.prs(arg1), Logo.prs(arg2));
    if(res == null) res = "";
    return res;
  }

//--------------------- Component related functions -----------------

  Object prim_setvisible(Object arg0, Object arg1, LContext lc){
    JComponent text = (JComponent)arg0;
    boolean state = Logo.aBoolean(arg1, lc);
    text.setVisible (state);
    return null;
  }

  Object prim_setsize(Object arg1, Object arg2, Object arg3, LContext lc){
    JComponent text = (JComponent)arg1;
    int w = Logo.anInt(arg2, lc), h = Logo.anInt(arg3, lc);
    text.setSize(w, h);
    return null;
  }

  Object prim_setlocation(Object arg1, Object arg2, Object arg3, LContext lc){
    JComponent text = (JComponent)arg1;
    int left = Logo.anInt(arg2, lc), top = Logo.anInt(arg3, lc);
    text.setLocation (left, top);
    return null;
  }

  Object prim_setforeground(Object arg1, Object arg2, LContext lc){
    JComponent cmp = (JComponent)arg1;
    Color c = new Color (Logo.anInt(arg2, lc));
    cmp.setForeground (c);
    return null;
  }

  Object prim_setbackground(Object arg1, Object arg2, LContext lc){
    JComponent cmp = (JComponent)arg1;
    Color c = new Color (Logo.anInt(arg2, lc));
    cmp.setBackground (c);
    return null;
  }


//------------------ Text related fcns --------------------------

  Object prim_inserttext(Object arg1, Object arg2, LContext lc){
    JTextArea text = prim_getTextObject(arg1, lc);
    String str= Logo.prs (arg2);
    int pos = text.getCaretPosition();
    text.insert(str, pos);
    return null;
  }

  Object prim_cleartext(Object arg1, LContext lc){
    JTextArea text = prim_getTextObject(arg1, lc);
    String txt = text.getText();
    text.replaceRange("", 0, txt.length());
    return null;
  }

  Object prim_gettext(Object arg1, LContext lc){
    JTextArea text = prim_getTextObject(arg1, lc);
    String str = text.getText();
    return str;
  }

  Object prim_getcursorpos(Object arg1, LContext lc){
    JTextArea text = prim_getTextObject(arg1, lc);
    int pos = text.getCaretPosition();
    return new Double (pos);
  }

  Object prim_setcursorpos(Object arg1, Object arg2, LContext lc){
    JTextArea text = prim_getTextObject(arg1, lc);
    int pos = Logo.anInt(arg2, lc);
    text.setCaretPosition(pos);
    return null;
  }


  public void initAppleKeys(JTextArea text) {
    // define the actions
    DefaultEditorKit.CutAction cutaction = new DefaultEditorKit.CutAction ();
    DefaultEditorKit.CopyAction copyaction = new DefaultEditorKit.CopyAction ();
    DefaultEditorKit.PasteAction pasteaction = new DefaultEditorKit.PasteAction ();
    SelectAllAction selectallaction = new SelectAllAction();


    // add the keymap to object
    Keymap keymap = text.getKeymap();
  // map the key strokes
  KeyStroke apple_x = KeyStroke.getKeyStroke(KeyEvent.VK_X, java.awt.event.InputEvent.META_MASK);
  KeyStroke apple_c = KeyStroke.getKeyStroke(KeyEvent.VK_C, java.awt.event.InputEvent.META_MASK);
  KeyStroke apple_v = KeyStroke.getKeyStroke(KeyEvent.VK_V, java.awt.event.InputEvent.META_MASK);
  KeyStroke apple_a = KeyStroke.getKeyStroke(KeyEvent.VK_A, java.awt.event.InputEvent.META_MASK);
  keymap.addActionForKeyStroke(apple_x, cutaction);
  keymap.addActionForKeyStroke(apple_c, copyaction);
  keymap.addActionForKeyStroke(apple_v, pasteaction);
  keymap.addActionForKeyStroke(apple_a, selectallaction);
  text.setKeymap(keymap);
  }



//------------------------ Cursors ----------------------------------------------------

  Object prim_createcursor(Object arg1, Object arg2, Object arg3, Object arg4, LContext lc){
    String name = Logo.prs (arg1);
    Point p = new Point (Logo.anInt(arg2, lc), Logo.anInt(arg3, lc));
    String filename = Logo.aString(arg4, lc);
    URL u = SpriteFrame.class.getResource("images/" + filename);
    if (u == null) Logo.error("can't get cursor  "+filename, lc);
    Image img = Toolkit.getDefaultToolkit().getImage(u);
    MediaTracker mt = new MediaTracker(lc.frame);
    try {
      mt.addImage(img, 0);
      mt.waitForID(0);
    }
    catch(Exception e) {Logo.error("can't get cursor "+" "+e+" "+filename, lc);}
    return lc.canvas.createCursor(img, p, name);
  }

  Object prim_setcursor(Object arg1, LContext lc){
    if(arg1 instanceof Number) lc.canvas.setCursorNumber(Logo.anInt(arg1, lc));
    else
      {Cursor c = (Cursor)arg1;
       lc.canvas.setCursor (c);
       }
    return null;
  }


//----------------------------Scroll bars -------------------------------
  Object prim_createscrollbar(Object arg0, Object arg1, Object arg2, Object arg3, Object arg4, LContext lc){
    JScrollBar scroll;
    int orientation = Logo.anInt(arg0, lc);
    Rectangle r = lc.canvas.getBounds();
    int left = Logo.anInt(arg1, lc), top = Logo.anInt(arg2, lc);
    int width = Logo.anInt(arg3, lc), height = Logo.anInt(arg4, lc);
    if (orientation == 1)  scroll = new JScrollBar(orientation, 0, 50, 0, 1000);
    else  scroll = new JScrollBar(orientation, 0, 50, 0, 1000);
    Color  c = new Color (163, 193, 255);
    scroll.setBackground (c);
    scroll.addAdjustmentListener(lc.canvas);
    scroll.setFocusable(false);
    lc.panel.add (scroll,0);
    double s = lc.frame.wscale;
    scroll.setBounds ((int)((left + r.x)*s), (int)((top + r.y)*s), (int)(width*s), (int)(height*s));
    scroll.setVisible (true);
    lc.panel.validate();
    return scroll;
  }

  Object prim_setscrollbarvalue(Object arg0, Object arg1, LContext lc){
    JScrollBar scroll = (JScrollBar)arg0;
    int value = Logo.anInt(arg1, lc);
    scroll.setValue(value);
    return null;
  }

  Object prim_scrollbarmaxsize(Object arg0, LContext lc){
    JScrollBar scroll = (JScrollBar)arg0;
    int n = scroll.getOrientation();
    if (n == 1) return new Double (scroll.getMaximumSize().getWidth());
    return new Double (scroll.getMaximumSize().getHeight());
  }


//------------------ file dialogs ----------------------------

File defaultpath = new File(System.getProperty("file.separator"));

 Object prim_filedialog(Object arg1, Object arg2, Object arg3, Object arg4, LContext lc){
   String name = Logo.prs(arg1);
   String ext = Logo.prs(arg2);
   String desc = Logo.prs(arg3);
   int mode = Logo.anInt (arg4, lc);
   String s = System.getProperty("os.name").toLowerCase();
   if(s.indexOf("mac")!=-1) return getFileDialog (name, ext, mode, lc);
   else return getFileChooser (name, ext, desc, mode, lc);
 }


Object getFileChooser (String name, String ext, String desc, int mode, LContext lc) {
   int result;
   JFileChooser chooser = new JFileChooser(defaultpath);
   chooser.setSelectedFile(new File(name));
   PicoFileFilter filter = new PicoFileFilter();
   filter.addExtension(ext);
   filter.setDescription(desc);
   chooser.setFileFilter(filter);
   if (mode == 0)   result = chooser.showOpenDialog(lc.frame);
   else result = chooser.showSaveDialog(lc.frame);
   defaultpath = chooser.getCurrentDirectory();
   if(result != JFileChooser.APPROVE_OPTION) return "";
   Object[] l = new Object[2];
   l[0] = chooser.getSelectedFile().getAbsolutePath();
   l[1] = chooser.getSelectedFile().getName();
   if (l[1] == null) return "";
   return l;
  }

  String currentdir = System.getProperty("user.dir")+"/Desktop";

  Object getFileDialog (String name, String ext, int mode,  LContext lc) {
    String title;
    Rectangle r1 = lc.canvas.getBounds();
    if (mode == 1)  title = "Save";
    else  title = "Open";
    FileDialog dialog = new FileDialog(lc.frame, title, mode);
    dialog.setDirectory(currentdir);
    dialog.setFile(name);
    Rectangle r2 = dialog.getBounds();
    int left = ( r1.width - r2.width) / 2, top = ( r1.height - r2.height) / 2;
    dialog.setLocation (left, top);
    dialog.setVisible(true);
//    dialog.setFilenameFilter(new PicoBlocksFiles());
    Object [] l = new Object[2];
    l[0] = (Object)((dialog.getDirectory()) + (dialog.getFile()));
    l[1] = dialog.getFile();
    if (l[1] == null) return "";
    currentdir = dialog.getDirectory();
    return l;
  }


//----------------------- Object type  -----------------------

  JTextArea prim_getTextObject (Object arg1, LContext lc) {
      String type = arg1.getClass().getName();
      if (type == "javax.swing.JScrollPane") {
        JScrollPane view = (JScrollPane)arg1;
        return (JTextArea)view.getViewport().getView();}
      else {
        return (JTextArea)arg1;}
  }



//------------------System extit ---------------------
  Object prim_setexit (Object arg1, LContext lc) {
     lc.shouldExit = Logo.aBoolean(arg1, lc);
     return null;
  }

 }



//--------------- Mac Key handling classes -----------------

class SelectAllAction extends AbstractAction implements Action {

    public void actionPerformed(ActionEvent e) {
      JTextArea text = (JTextArea)e.getSource();
      text.selectAll();
     // e.consume();
    }
}

